<block-ui message="Loading..."> </block-ui>
<div class="col-xl-12 c-alert pl-0 pr-0">
  <app-alert [message]="message" [type]="type" id="alert"></app-alert>
</div>
<div class="mb-3 mt-3 blucolor" id="heading">
  {{ addItem ? "Add Treatment Notes Template" : "Edit Treatment Notes Template" }}
</div>
<div>
  <div class="form-group row mb-0">
    <div class="col-xl-6">
      <div class="tab bg-white">
        <div class="row">
          <div class="col-xl-6 d-flex align-items-center">
            <button class="tablinks active ">
              <span class="normal_18px_font lightcolor">Items</span>
            </button>
          </div>
          <div *ngIf="itemid" class="col-xl-6 d-flex justify-content-end">
            <a href="javascript:void(0)" (click)="openCopyTemplate()" matTooltip="Duplicate" style="    padding: 11px 18px 0px 0px;">
              <img src="../../../assets/copy-files.png" alt="" />
            </a>
            <a href="javascript:void(0)" (click)="shareTemplate()" matTooltip="Share to Library" style="    padding: 11px 18px 0px 0px;">
              <img src="../../../assets/sharei.png" alt="" />
            </a>
          </div>
        </div>
      </div>
      <div class="tabcontent tabcontent-padding bg-white">
        <form autocomplete="off" [formGroup]="treatmentNotesForm">
          <div class="row" style="max-height: 610px;overflow-y: scroll;overflow-x: hidden;">
            <div class="col-xl-5 kendo-dropdown-label"></div>
            <div class="col-xl-4 d-flex justify-content-end" style="padding-bottom: 5px;">
              <span class="normal_13px_15px_font normalhelfont grey">Required</span>
            </div>
            <div class="col-xl-9 col-lg-9 d-block align-items-center">
              <mat-form-field [appearance]="apperance" class="full-width" id="templatename-field">
                <mat-label *ngIf="addItem">Template Name</mat-label>
                <input matInput required placeholder="Template Name" formControlName="templateName" [errorStateMatcher]="matcher" [value]="treatmentNotes.templateName" #templateName (input)="templateNameChange(templateName.value)"
                       appCharLimit [frmGroup]="treatmentNotesForm" fcName="templateName" [max]="100">

                <mat-error *ngIf="treatmentNotesForm.get('templateName').hasError('exceedLimit')">
                  {{treatmentNotesForm.get('templateName').getError('exceedLimit')}}
                </mat-error>

                <mat-error *ngIf="treatmentNotesForm.get('templateName').hasError('required')">
                  This field is required.
                </mat-error>
              </mat-form-field>
            </div>
            <div class="col-xl-3 col-lg-3 d-block align-items-center">
              <div class=" add-item-btn" style="padding-top: 0 !important;">
                <button mat-raised-button color="accent" class="mr-2  w-100 p-0 " type="button" (click)="onAddItem()">
                  <div class="button-text-wrapper">Add Item</div>
                </button>
              </div>
            </div>
            <div class="col-xl-6 col-lg-6">
              <div class="row  ml-0 mr-0  align-items-center justify-content-between ">
                <h5 class="my-0 mr-2">Apply to location</h5>
                <kendo-switch [onLabel]="'All'" [offLabel]="'Selected'" (valueChange)="allLocationChange($event)" class="mt-3 mb-3 wide-switch" formControlName="allowLocation" [(ngModel)]="value">
                </kendo-switch>
              </div>
            </div>
            <div class="col-xl-6 col-lg-6"></div>
            <div class="col-xl-6 col-lg-6">
              <div class="d-flex justify-content-end " style="padding-bottom: 5px;">
                <div class="normal_13px_15px_font normalhelfont grey">Required</div>
              </div>
              <!-- Location  -->
              <div class="align-items-center" style="padding-bottom:30px;">
                <mat-form-field appearance="outline">
                  <mat-label>Location Name</mat-label>
                  <app-kendo-multi-select required formControlName="templateLocation" [textField]="'locationName'"
                                          [value]="treatmentNotes.treatmentNotesTemplateLocation"
                                          [valueField]="'locationId'" [data]="locationData" [filterable]="true"
                                          (valueChanged)="onLocationChange($event)"></app-kendo-multi-select>

                  <mat-error *ngIf="treatmentNotes.treatmentNotesTemplateLocation == null && treatmentNotesForm.get('templateLocation').hasError('required')">
                    This field is required.
                  </mat-error>
                </mat-form-field>
              </div>
            </div>
            <div class="col-xl-6 col-lg-6">
              <div class="d-flex justify-content-end " style="padding-bottom: 5px;">
                <div class="normal_13px_15px_font normalhelfont grey">Required</div>
              </div>
              <!-- speciality  -->
              <div class=" align-items-center" style="padding-bottom:30px;">
                <mat-form-field appearance="outline">
                  <mat-label>Speciality Name</mat-label>
                  <app-kendo-multi-select required [data]="groupedSpecialityData"
                                          placeholder="Speciality Name"
                                          [filterable]="true"
                                          [textField]="'specialityName'"
                                          [valueField]="'idAndLocationId'"
                                          formControlName="specialityName"
                                          [value]="treatmentNotes.treatmentNotesTemplateSpeciality"
                                          (valueChanged)="onSpecialityChange($event)"></app-kendo-multi-select>

                  <mat-error *ngIf="treatmentNotesForm.get('specialityName').hasError('required')">
                    This field is required.
                  </mat-error>
                </mat-form-field>

<!--                <kendo-formfield showErrors="initial">-->
<!--                  <kendo-multiselect [data]="groupedSpecialityData" placeholder="Speciality Name" [filterable]="true" [textField]="'specialityName'" required [valueField]="'idAndLocationId'" formControlName="specialityName" [value]="treatmentNotes.treatmentNotesTemplateSpeciality"-->
<!--                                     (valueChange)="onSpecialityChange($event)" style="height: 54px">-->
<!--                  </kendo-multiselect>-->
<!--                  <kendo-formerror *ngIf="treatmentNotesForm.controls.specialityName.errors?.required">-->
<!--                    This field is required-->
<!--                  </kendo-formerror>-->
<!--                </kendo-formfield>-->
              </div>
            </div>
          </div>
        </form>

        <form autocomplete="off" [formGroup]="treatmentNotesLibraryForm">
          <div class="row" style="max-height: 610px;overflow-y: scroll;overflow-x: hidden;">
            <div class="kendo-panel-bar-width mt-3 tabcontent-no-item">
              <!-- Expansion Panel -->
              <div *ngIf="!isItemAdded" class="treatinfo-wrapper">

                <img src="../../../assets/info.png" alt="" style="padding: 12px 14px 34px 17px;" />

                <span class="normal_16px_44px_font normalhelfont dark-grey" style="line-height: 28px !important;">
                  This
                  Treatment Notes
                  Template is currently empty. Click on "Add Item button" to add
                  new templates.
                </span>

              </div>
              <mat-accordion cdkDropList (cdkDropListDropped)="drop($event)">
                <mat-expansion-panel *ngFor="let tn of treatmentNotes.itemTypeModel; let i=index;" cdkDrag (opened)="panelOpenState = true" [expanded]="tn.isOpen" (closed)="panelOpenState = false">
                  <mat-expansion-panel-header class="c-mat-expansion-panel-header">
                    <div class="material-icons" style="font-size: 38px;padding: 23px 20px 23px 4px;color: #939393;
                    ">
                      drag_indicator
                    </div>
                    <div>
                      <mat-panel-title *ngIf="tn.itemLabel === ''" class="mat-expansion-panel-header-title-accord mattitle-wrapper">
                        Item {{ tn.id }}
                      </mat-panel-title>
                      <mat-panel-title *ngIf="tn.itemLabel !== ''" class="mat-expansion-panel-header-title-accord mattitle-wrapper">
                        {{ tn.itemLabel }}
                      </mat-panel-title>
                      <mat-panel-description class="mat-expansion-panel-header-description-accord matdesc-wrapper">
                        {{ tn.itemTypeText }}
                      </mat-panel-description>
                    </div>
                  </mat-expansion-panel-header>

                  <ng-container *ngIf="tn">
                    <div formArrayName="items">
                      <div [formGroupName]="i">
                        <!-- Item Type Data Start -->
                        <div class="col-xl-12 itemtypelist-wrapper mt-2 pl-0 pr-0" style="padding-bottom: 1.34375em;">
                          <label class="mat-expansion-panel-header-title">Item Type*</label>
                          <kendo-formfield showErrors="initial">
                            <kendo-dropdownlist [data]="itemTypesData" [textField]="'title'" [valuePrimitive]="true" [defaultItem]="placeHolder" formControlName="itemDropdown" [valueField]="'id'" class="itemtype-wrapper c-itemtype-wrapper" (valueChange)="handleItemTypeChange(tn.id, $event,i)"
                                                [(ngModel)]="tn.itemTypeId">
                              <ng-template kendoDropDownListValueTemplate kendoDropDownListItemTemplate let-dataItem>
                                <div class="col-xl-12 row mb-1 mt-1">
                                  <div class="d-flex align-items-center w-100">
                                    <div>
                                      <span class="material-icons material-icons-style">
                                        {{ dataItem?.icon }}
                                      </span>
                                    </div>
                                    <div class="w-100">
                                      <div class="col-xl-12 align-items-center">
                                        <span class="item-type-heading">
                                          {{
                                                                                    dataItem?.title
                                          }}
                                        </span>
                                      </div>
                                      <div class="col-xl-12 align-items-center">
                                        <span class="item-type-description">
                                          {{ dataItem?.description }}
                                        </span>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                              </ng-template>

                            </kendo-dropdownlist>
                            <mat-error *ngIf="(item.controls[i].get('itemDropdown').touched && !tn.itemTypeId) || (isSubmitted && !tn.itemTypeId)" style="margin-top: 0.6666666667em;">
                              This field is required
                            </mat-error>
                          </kendo-formfield>
                        </div>
                        <!-- Item Type Data End -->
                        <!-- Label  -->
                        <div class="col-xl-12 traetmentlabel-wrapper pl-0 pr-0" *ngIf="
                        tn.itemTypeText !== 'Spine' &&
                        tn.itemTypeText !== 'Vitals'
                        ">
                          <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Label</mat-label>

                            <input matInput placeholder="Label" [value]="tn.itemLabel" formControlName="lable" #label (input)="labelChange(tn.id, label.value,i)" [errorStateMatcher]="matcher" (mousedown)="touch($event,i)" />
                            <mat-error *ngIf="(item.controls[i].get('lable').errors?.required  && item.controls[i].get('lable').touched) || isSubmitted">
                              This field is required.
                            </mat-error>


                          </mat-form-field>
                        </div>

                        <!-- Duplicate Label  -->
                        <div *ngIf="tn.showMirrored" class="col-xl-12 pl-0 pr-0">
                          <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Label</mat-label>
                            <input matInput placeholder="Label" [value]="tn.itemLabelDuplicate" (mousedown)="touch($event,i)" #duplicateLabel formControlName="duplicateLabel" [errorStateMatcher]="matcher" (input)="
                            duplicateLabelChange(tn.id, duplicateLabel.value)
                            " />
                            <mat-error *ngIf="(item.controls[i].get('duplicateLabel').errors?.required && item.controls[i].get('duplicateLabel').touched) || isSubmitted">
                              This field is required.
                            </mat-error>
                          </mat-form-field>
                        </div>


                        <div class="col-xl-12 pl-0 pr-0">
                          <!-- Date Time -->
                          <div *ngIf="tn.itemTypeText === 'Date Time'" class="traetmentdate-wrapper" class="row">
                            <div class="col-xl-6 mb-2" style="padding-bottom: 1.34375em;">
                              <kendo-formfield showErrors="initial">
                                <kendo-datepicker [format]="'dd/MM/yyyy'" placeholder="Date..." formControlName="date" [(ngModel)]="tn.dateTime.date" (valueChange)="onDateChange(tn.id, $event)" style="height: 54px;width: 100%;">
                                </kendo-datepicker>
                                <kendo-formerror *ngIf="(item.controls[i].get('date').errors?.required && item.controls[i].get('date').touched) || isSubmitted">
                                  This field is required
                                </kendo-formerror>
                              </kendo-formfield>

                            </div>
                            <div class="col-xl-6 " style="padding-bottom: 1.34375em;">
                              <mat-form-field appearance="outline">
                                <mat-label>Time</mat-label>
                                <app-time-picker formControlName="time" label="Time" (valueChange)="onTimeChange(tn.id, $event)" [interval]="30"></app-time-picker>

                                  <mat-error *ngIf="(item.controls[i].get('time').errors?.required && item.controls[i].get('time').touched) || isSubmitted" style="margin-bottom: 0 !important;">
                                      This field is required
                                  </mat-error>
                              </mat-form-field>
<!--                              <vaadin-time-picker id="time-picker-wrapper" placeholder="Time..." matInput [(ngModel)]="tn.dateTime.time" formControlName="time" ngDefaultControl (valueChange)="onTimeChange(tn.id, $event)" style="height: 54px;width: 100%;" [errorStateMatcher]="matcher"></vaadin-time-picker>-->

                            </div>


                            <!-- Duplicate Date Time -->
                            <div class="col-xl-6 " *ngIf="tn.showMirrored" style="padding-bottom: 1.34375em;">
                              <kendo-formfield showErrors="initial">
                                <kendo-datepicker [format]="'dd/MM/yyyy'" placeholder="Date..." formControlName="duplicatedate" [(ngModel)]="tn.dateTimeDuplicate.date" (valueChange)="onDuplicateDateChange(tn.id, $event)" style="height: 54px;width: 100%;">
                                  <kendo-formerror *ngIf="(item.controls[i].get('duplicatedate').errors?.required && item.controls[i].get('duplicatedate').touched) || isSubmitted">
                                    This field is required
                                  </kendo-formerror>
                                </kendo-datepicker>
                              </kendo-formfield>

                            </div>
                            <div class="col-xl-6 " *ngIf="tn.showMirrored" style="padding-bottom: 1.34375em;">
                              <vaadin-time-picker id="time-picker-wrapper" placeholder="Time..." [(ngModel)]="tn.dateTime.time" formControlName="time" ngDefaultControl (valueChange)="onTimeChange(tn.id, $event)" style="height: 54px;width: 100%;"></vaadin-time-picker>
                              <mat-error *ngIf="tn.dateTime.time==null && (item.controls[i].get('duplicatetime').errors?.required && item.controls[i].get('duplicatetime').touched) || isSubmitted" style="margin-bottom: 0px !important;">
                                This field is required
                              </mat-error>

                            </div>
                          </div>


                          <!-- Text -->
                          <div *ngIf="tn.itemTypeText === 'Text'">
                            <div>
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Note</mat-label>
                                <textarea matInput rows="4" [value]="tn.text" #text (input)="textChange(tn.id, text.value)"></textarea>

                              </mat-form-field>
                            </div>

                            <!-- Duplicate Text -->
                            <div *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Note</mat-label>
                                <textarea matInput [value]="tn.textDuplicate" rows="4" #textDuplicate (input)="
                                textDuplicateChange(tn.id, textDuplicate.value)
                                "></textarea>

                              </mat-form-field>
                            </div>
                          </div>

                          <!-- Number -->
                          <div *ngIf="tn.itemTypeText === 'Number'" class="row">
                            <div class="col-xl-4">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Minimum Value</mat-label>

                                <input matInput placeholder="Minimum Value" type="number" formControlName="minNumber" [errorStateMatcher]="matcher" [value]="tn.number.minimum" #minimumValue (input)="
                                numberChange(
                                    tn.id,
                                    minimumValue.value,
                                    'Minimum'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('minNumber').errors?.required  && item.controls[i].get('minNumber').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4 ">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Maximum Value</mat-label>
                                <input matInput placeholder="Maximum Value" formControlName="maxNumber" type="number" [errorStateMatcher]="matcher" [value]="tn.number.maximum" #maximumValue (input)="
                                numberChange(
                                    tn.id,
                                    maximumValue.value,
                                    'Maximum'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('maxNumber').errors?.required  && item.controls[i].get('maxNumber').touched)|| isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Value</mat-label>
                                <input matInput placeholder="Default Value" formControlName="defaultNumber" [errorStateMatcher]="matcher" [value]="tn.number.default" type="number" #defaultValue (input)="
                                numberChange(
                                    tn.id,
                                    defaultValue.value,
                                    'Default'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('defaultNumber').errors?.required && item.controls[i].get('defaultNumber').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>

                            <!-- Duplicate Number -->
                            <div class="col-xl-4" *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Minimum Value</mat-label>
                                <input matInput placeholder="Minimum Value" formControlName="duplicateminNumber" [errorStateMatcher]="matcher" type="number" [value]="tn.numberDuplicate.minimum" #minimumDuplicateValue (input)="
                                numberChange(
                                    tn.id,
                                    minimumDuplicateValue.value,
                                    'Minimum Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicateminNumber').errors?.required && item.controls[i].get('duplicateminNumber').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4 " *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Maximum Value</mat-label>
                                <input matInput placeholder="Maximum Value" type="number" formControlName="duplicatemaxNumber" [errorStateMatcher]="matcher" [value]="tn.numberDuplicate.maximum" #maximumDuplicateValue (input)="
                                numberChange(
                                    tn.id,
                                    maximumDuplicateValue.value,
                                    'Maximum Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicatemaxNumber').errors?.required && item.controls[i].get('duplicatemaxNumber').touched)|| isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4" *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Value</mat-label>
                                <input matInput placeholder="Default Value" type="number" formControlName="duplicatedefaultNumber" [errorStateMatcher]="matcher" [value]="tn.numberDuplicate.default" #defaultDuplicateValue (input)="
                                numberChange(
                                    tn.id,
                                    defaultDuplicateValue.value,
                                    'Default Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicatedefaultNumber').errors?.required && item.controls[i].get('duplicatedefaultNumber').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>
                              </mat-form-field>
                            </div>
                          </div>
                          <!-- Dropdown -->
                          <div *ngIf="tn.itemTypeText === 'Dropdown'">
                            <div class=" row">
                              <div class="col-xl-3 droupdowntext-wrapper">
                                Dropdown Values
                              </div>
                              <div class="col-xl-9 d-block">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removeDropdownSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let d of tn.dropdowns" class="ml-0 mr-0 mb-3 row">

                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <mat-radio-button color="warn" value="d.id" name="rbDropDown" [checked]="d.default" matTooltip="Set as Default" (change)="selectedDropDownDefault(tn.id, d.id)" style="    padding: 7px 15px 8px 5px;">
                                      </mat-radio-button>

                                      <input matInput formControlName="dropdown" [errorStateMatcher]="matcher" (input)="
                                inputDropDownValue(tn.id, d.id, $event)
                                " placeholder="Need to type the value" [value]="d.value"
                                             appCharLimit [frmGroup]="item.controls[i]" fcName="dropdown" [max]="100"/>

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeDropDownOption(tn.id, d.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>

                                  <mat-error *ngIf="item.controls[i].get('dropdown').errors?.required && isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>
                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addDropDownOption(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <div class=" row">
                              <!-- Duplicate Dropdown -->
                              <div *ngIf="tn.showMirrored" class="col-xl-3 droupdowntext-wrapper">
                                Dropdown Values
                              </div>
                              <div class="col-xl-9 d-block" *ngIf="tn.showMirrored">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removeDuplicateDropdownSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let dd of tn.duplicateDropdowns" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <mat-radio-button color="warn" value="dd.id" name="rbDropDownDuplicate" [checked]="dd.default" matTooltip="Set as Default" (change)="selectedDropDownDuplicateDefault(tn.id, dd.id)" style="    padding: 7px 15px 8px 5px;">
                                      </mat-radio-button>

                                      <input matInput [errorStateMatcher]="matcher" formControlName="duplicatedropdown" (input)="
                                inputDropDownDuplicateValue(
                                    tn.id,
                                    dd.id,
                                    $event
                                )
                                    " placeholder="Need to type the value" [value]="dd.value" />

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeDuplicateDropDownOption(tn.id, dd.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('duplicatedropdown').errors?.required && isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addDuplicateDropDownOption(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </div>
                          <!-- Radio Button -->

                          <div *ngIf="tn.itemTypeText === 'Radio Buttons'">

                            <div class="row">
                              <div class="col-xl-3 droupdowntext-wrapper">
                                Radio Button Values
                              </div>
                              <div class="col-xl-9 d-block">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removeRadiobuttonSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let rd of tn.radioButtons" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">

                                      <mat-radio-group>
                                        <mat-radio-button color="warn" value="rd.id" [checked]="rd.default" matTooltip="Set as Default" (change)="selectedRadioButtonDefault(tn.id, rd.id)" style="    padding: 7px 15px 8px 5px;">
                                        </mat-radio-button>
                                      </mat-radio-group>
                                      <input matInput #radioField [errorStateMatcher]="matcher" formControlName="radiobutton" (input)="inputRadioButtonValue(tn.id, rd.id, $event)"
                                             placeholder="Need to type the value" [value]="rd.value"
                                             appCharLimit [frmGroup]="item.controls[i]" fcName="radiobutton" [max]="100"/>

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeRadioButtonOption(tn.id, rd.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>

                                  <mat-error *ngIf="radioField.value.length > 100">
                                    You can't type more than 100 characters.
                                  </mat-error>

                                  <mat-error *ngIf="item.controls[i].get('radiobutton').errors?.required && isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>


                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addRadioButtonOption(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <!-- Duplicate Radio Button -->
                            <div class="row">

                              <div *ngIf="tn.showMirrored" class="col-xl-3 droupdowntext-wrapper">
                                Radio Button Values
                              </div>
                              <div class="col-xl-9 d-block" *ngIf="tn.showMirrored">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removeDuplicateRadiobuttonSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let rdd of tn.duplicateRadioButtons" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <mat-radio-button color="warn" value="rdd.id" name="rbDropDownDuplicate" [checked]="rdd.default" matTooltip="Set as Default" (change)="selectedRadioButtonDuplicateDefault(tn.id, rdd.id)" style="    padding: 7px 15px 8px 5px;">
                                      </mat-radio-button>
                                      <input matInput formControlName="duplicateradiobutton" [errorStateMatcher]="matcher" (input)="
                                inputRadioButtonDuplicateValue(
                                    tn.id,
                                    rdd.id,
                                    $event
                                    )
                                    " placeholder="Need to type the value" [value]="rdd.value" />

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeDuplicateRadioButtonOption(tn.id,rdd.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('duplicateradiobutton').errors?.required && isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addDuplicateRadioButtonOption(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </div>
                          <!-- Check Boxes -->
                          <div *ngIf="tn.itemTypeText === 'Check Boxes'">

                            <div class="row">
                              <div class="col-xl-3 droupdowntext-wrapper">
                                Check Boxes Values
                              </div>
                              <div class="col-xl-9 d-block">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removedCheckBoxSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let cb of tn.checkBoxes" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">

                                      <mat-checkbox class="ml-2 mt-2 mr-2 normal-checkbox" #checkbox color="warn" value="cb.id" [checked]="cb.default" matTooltip="Set as Default" (change)="
                                    selectedCheckBoxDefault(
                                    tn.id,
                                    cb.id,
                                    checkbox.checked
                                    )
                                " style="padding: 7px 15px 8px 5px;">
                                      </mat-checkbox>

                                      <input matInput formControlName="checkbox" [errorStateMatcher]="matcher" (input)="
                                inputCheckBoxValue(tn.id, cb.id, $event)
                                    " placeholder="Need to type the value" [value]="cb.value"
                                             appCharLimit [frmGroup]="item.controls[i]" fcName="checkbox" [max]="100"/>
                                    </div>

                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeCheckBox(tn.id, cb.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('checkbox').errors?.required &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addCheckBox(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <!-- Duplicate Check Boxes -->

                            <div class="row">

                              <div *ngIf="tn.showMirrored" class="col-xl-3 droupdowntext-wrapper">
                                Check Boxes Values
                              </div>
                              <div class="col-xl-9 d-block" *ngIf="tn.showMirrored">
                                <div style="padding-bottom: 2px;">
                                  <a href="javascript:void(0)" (click)="removedDuplicateCheckBoxSetAsDefault(tn.id)" class="defaulttext-wrapper">No Default</a>
                                </div>
                                <div *ngFor="let cbd of tn.checkBoxesDuplicate" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">

                                      <mat-checkbox class="ml-2 mt-2 mr-2 normal-checkbox" color="warn" value="cbd.id" #checkboxDuplicate [checked]="cbd.default" matTooltip="Set as Default" (change)="
                                selectedRadioButtonDuplicateDefault(tn.id, cbd.id)
                                ">
                                      </mat-checkbox>
                                      <input matInput formControlName="duplicatecheckbox" [errorStateMatcher]="matcher" (input)="
                                inputCheckBoxDuplicateValue(
                                    tn.id,
                                    cbd.id,
                                    $event
                                )
                                    " placeholder="Need to type the value" [value]="cbd.value" />


                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeDuplicateCheckBox(tn.id, cbd.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('duplicatecheckbox').errors?.required  &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addDuplicateCheckBox(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </div>
                          <!-- End Duplicate Check Boxes -->
                          <!-- Range or Scale -->
                          <div *ngIf="tn.itemTypeText === 'Range or Scale'" class="row">
                            <div class="col-xl-4">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Minimum Value</mat-label>
                                <input matInput placeholder="Minimum  Value" formControlName="minRange" [errorStateMatcher]="matcher" type="number" [value]="tn.rangeOrScale.minimum" #minimumValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    minimumValue.value,
                                    'Minimum'
                                )
                                " min="0" />
                                <mat-error *ngIf="(item.controls[i].get('minRange').errors?.required && item.controls[i].get('minRange').touched)  || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Maximum Value</mat-label>
                                <input matInput placeholder="Maximum Value" [errorStateMatcher]="matcher" formControlName="maxRange" type="number" [value]="tn.rangeOrScale.maximum" #maximumValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    maximumValue.value,
                                    'Maximum'
                                )
                                " max="10" />
                                <mat-error *ngIf="(item.controls[i].get('maxRange').errors?.required && item.controls[i].get('maxRange').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Value</mat-label>
                                <input matInput placeholder="Default Value" [errorStateMatcher]="matcher" formControlName="defaultRange" type="number" [value]="tn.rangeOrScale.default" #defaultValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    defaultValue.value,
                                    'Default'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('defaultRange').errors?.required && item.controls[i].get('defaultRange').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                              <mat-hint *ngIf="defautDuplicatemessage">Please add Value between min and max.</mat-hint>
                            </div>
                            <!-- Duplicate  Range or Scale -->
                            <div class="col-xl-4" *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Minimum Value</mat-label>
                                <input matInput placeholder="Minimum Value" [errorStateMatcher]="matcher" min="0" formControlName="duplicateminRange" type="number" [value]="tn.rangeOrScaleDuplicate.minimum" #minimumDuplicateValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    minimumDuplicateValue.value,
                                    'Minimum Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicateminRange').errors?.required  && item.controls[i].get('duplicateminRange').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4" *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Maximum Value</mat-label>
                                <input matInput placeholder="Maximum Value" [errorStateMatcher]="matcher" formControlName="duplicatemaxRange" type="number" max="10" [value]="tn.rangeOrScaleDuplicate.maximum" #maximumDuplicateValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    maximumDuplicateValue.value,
                                    'Maximum Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicatemaxRange').errors?.required && item.controls[i].get('duplicatemaxRange').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                                <mat-hint *ngIf="maxDuplicatemessage">Please add Value between min and max.</mat-hint>
                              </mat-form-field>
                            </div>
                            <div class="col-xl-4" *ngIf="tn.showMirrored">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Value</mat-label>
                                <input matInput placeholder="Default Value" [errorStateMatcher]="matcher" formControlName="duplicatedefaultRange" max="10" type="number" [value]="tn.rangeOrScaleDuplicate.default" #defaultDuplicateValue (input)="
                                rangeOrScaleChange(
                                    tn.id,
                                    defaultDuplicateValue.value,
                                    'Default Duplicate'
                                )
                                " />
                                <mat-error *ngIf="(item.controls[i].get('duplicatedefaultRange').errors?.required && item.controls[i].get('duplicatedefaultRange').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>


                              </mat-form-field>
                              <mat-hint *ngIf="defautDuplicatemessage">Please add Value between min and max.</mat-hint>
                            </div>
                          </div>

                          <!-- Option List -->
                          <div *ngIf="tn.itemTypeText === 'Option List'">

                            <div class="row">
                              <div class="col-xl-3">
                                Styles
                              </div>
                              <div class="col-xl-9">
                                <mat-form-field [appearance]="apperance" class="full-width">
                                  <mat-select [value]="tn.optionListStyleId" (valueChange)="
                                    optionListStylesChange(tn.id, $event)
                                ">
                                    <mat-option *ngFor="let o of optionListStyles" [value]="o.id">
                                      {{ o.type }}
                                    </mat-option>
                                  </mat-select>
                                </mat-form-field>
                              </div>
                            </div>
                            <div class="row">
                              <div class="col-xl-3">
                                Subjects
                              </div>
                              <div class="col-xl-9">

                                <div *ngFor="let s of tn.optionListSubjects" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <input matInput formControlName="subjectinput" [errorStateMatcher]="matcher" (input)="
                                    inputOptionListSubjectValue(
                                        tn.id,
                                        s.id,
                                        $event
                                    )
                                    " placeholder="Need to type the value" [value]="s.value" />

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeOptionListSubject(tn.id, s.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('subjectinput').errors?.required &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper" (click)="addOptionListSubject(tn.id)">
                                    <a href="javascript:void(0)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <div class="row">
                              <div class="col-xl-3">
                                Choices
                              </div>
                              <div class="col-xl-9">
                                <div *ngFor="let c of tn.optionListChoices" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <input matInput formControlName="choiceinput" [errorStateMatcher]="matcher" (input)="
                                    inputOptionListChoiceValue(
                                        tn.id,
                                        c.id,
                                        $event
                                    )
                                    " placeholder="Need to type the value" [value]="c.value" />

                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeOptionListChoice(tn.id, c.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('choiceinput').errors?.required &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper" (click)="addOptionListChoice(tn.id)">
                                    <a href="javascript:void(0)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>


                            <!-- Duplicate Option List -->
                            <div class="row" *ngIf="tn.showMirrored">
                              <div class="col-xl-3">
                                Styles
                              </div>
                              <div class="col-xl-9">
                                <mat-form-field [appearance]="apperance" class="full-width">
                                  <mat-select [value]="tn.optionListStyleDuplicateId" (valueChange)="
                                optionListStylesDuplicateChange(tn.id, $event)">
                                    <mat-option *ngFor="let o of optionListStyles" [value]="o.id">
                                      {{ o.type }}
                                    </mat-option>
                                  </mat-select>
                                </mat-form-field>
                              </div>
                            </div>
                            <div class="row" *ngIf="tn.showMirrored">
                              <div class="col-xl-3">
                                Subjects
                              </div>
                              <div class="col-xl-9">

                                <div *ngFor="let s of tn.optionListSubjectsDuplicate" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <input matInput formControlName="duplicatesubjectinput" [errorStateMatcher]="matcher" (input)="
                                                                                                        inputOptionListSubjectDuplicateValue(
                                                                                                            tn.id,
                                                                                                            s.id,
                                                                                                            $event
                                                                                                    )
                                                                                                    " placeholder="Need to type the value" [value]="s.value" />
                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeOptionListSubjectDuplicate(tn.id, s.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('duplicatesubjectinput').errors?.required &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>

                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addOptionListSubjectDuplicate(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <div class="row" *ngIf="tn.showMirrored">
                              <div class="col-xl-3">
                                Choices
                              </div>
                              <div class="col-xl-9">
                                <div *ngFor="let c of tn.optionListChoicesDuplicate" class="ml-0 mr-0 mb-3 row">
                                  <div class="radio-button-style" style="display: flex;align-items: center;">
                                    <div class="col-xl-10 d-flex align-items-center justify-content-between">
                                      <input matInput [errorStateMatcher]="matcher" formControlName="duplicatechoiceinput" (input)="
                                    inputOptionListChoiceDuplicateValue(
                                        tn.id,
                                        c.id,
                                        $event
                                    )
                                    " placeholder="Need to type the value" [value]="c.value" />


                                    </div>
                                    <div class="col-xl-2">
                                      <a href="javascript:void(0)" class="dash-wrapper" (click)="removeOptionListChoiceDuplicate(tn.id, c.id)">
                                        <img src="../../../assets/dash.png" alt="" />
                                      </a>
                                    </div>
                                  </div>
                                  <mat-error *ngIf="item.controls[i].get('duplicatechoiceinput').errors?.required &&  isSubmitted" style="margin-top: 0.6666666667em;">
                                    This field is required.
                                  </mat-error>
                                </div>
                                <div class="mb-3">
                                  <div class="adddrowpdown-wrapper">
                                    <a href="javascript:void(0)" (click)="addOptionListChoiceDuplicate(tn.id)">
                                      <img src="../../../assets/Add1.png" alt="" />
                                    </a>
                                  </div>
                                </div>
                              </div>
                            </div>

                          </div>

                          <div *ngIf="tn.itemTypeText === 'Table'" class="row">
                            <!-- Table -->
                            <div class="col-xl-4 d-flex">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Rows</mat-label>
                                <mat-select [value]="tn.table.rows" [errorStateMatcher]="matcher" formControlName="row" (valueChange)="tableRowChange(tn.id, $event)">
                                  <mat-option *ngFor="let t of maxTableRowsColumns" [value]="t">
                                    {{ t }}
                                  </mat-option>
                                </mat-select>
                                <mat-error *ngIf="(item.controls[i].get('row').errors?.required && item.controls[i].get('row').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-4 d-flex">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Columns</mat-label>
                                <mat-select [value]="tn.table.columns" [errorStateMatcher]="matcher" formControlName="column" (valueChange)="tableColumnChange(tn.id, $event)">
                                  <mat-option *ngFor="let t of maxTableRowsColumns" [value]="t">
                                    {{ t }}
                                  </mat-option>
                                </mat-select>
                                <mat-error *ngIf="(item.controls[i].get('column').errors?.required && item.controls[i].get('column').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div *ngIf="tn.table.rowHeader.length > 0" class="col-xl-12 tabletext-wrapper">
                              Row headers
                            </div>
                            <div class="row" style="padding: 0px 10px 0px 13px;">
                              <div class="col-xl-3" *ngFor="let t of tn.table.rowHeader">
                                <mat-form-field [appearance]="apperance" class="matinputwrapper mr-1">
                                  <mat-label>Header {{ t.id }}</mat-label>
                                  <input matInput maxlength="20" [value]="t.value" [errorStateMatcher]="matcher" formControlName="rowheader" (input)="tableRowHeaderInput(tn.id, t.id, $event)" />
                                  <mat-error *ngIf="(item.controls[i].get('rowheader').errors?.required && item.controls[i].get('rowheader').touched) || isSubmitted">
                                    This field is required.
                                  </mat-error>

                                </mat-form-field>
                              </div>
                            </div>
                            <div *ngIf="tn.table.columnHeader.length > 0" class="col-xl-12 tabletext-wrapper">
                              Column headers
                            </div>
                            <div class="row" style="padding: 0px 10px 0px 13px;">
                              <div class="col-xl-3" *ngFor="let t of tn.table.columnHeader">
                                <mat-form-field [appearance]="apperance" class="matinputwrapper mr-1">
                                  <mat-label>Header {{ t.id }}</mat-label>
                                  <input matInput maxlength="20" [value]="t.value" [errorStateMatcher]="matcher" formControlName="columnheader" (input)="tableColumnHeaderInput(tn.id, t.id, $event)" />
                                  <mat-error *ngIf="(item.controls[i].get('columnheader').errors?.required && item.controls[i].get('columnheader').touched) || isSubmitted">
                                    This field is required.
                                  </mat-error>

                                </mat-form-field>
                              </div>
                            </div>
                          </div>

                          <!-- Chart -->
                          <div *ngIf="tn.itemTypeText === 'Chart'" class="row" style="margin: 0;">
                            <div class="col-xl-12 traetmentdulicatelabel-wrapper" style="padding:0 !important">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-select [value]="chartSize" formControlName="chartsize" [errorStateMatcher]="matcher" (valueChange)="chartChange(tn.id, $event)">
                                  <mat-option value="Small">Small</mat-option>
                                  <mat-option value="Medium">Medium</mat-option>
                                  <mat-option value="Large">Large</mat-option>
                                </mat-select>
                                <mat-error *ngIf="(item.controls[i].get('chartsize').errors?.required && item.controls[i].get('chartsize').touched) || isSubmitted">
                                  This field is required.
                                </mat-error>

                              </mat-form-field>
                            </div>
                            <div class="col-xl-12 chart-wrapper mb-3">
                              <app-image-file-upload [headerDescription]=" headerDescription" [source]="tn.chartImage.tempImage" (parentChartCallBack)="
                                parentChartCallBack(tn.id, $event)
                            " style="padding:0 !important;"></app-image-file-upload>
                            </div>
                          </div>

                          <!-- File Attachment -->
                          <div *ngIf="tn.itemTypeText === 'File Attachment'" class="row">
                            <div class="col-xl-12" style="margin-bottom: 20px;">
                              <kendo-upload [disabled]="true" [saveUrl]="uploadSaveUrl" [removeUrl]="uploadRemoveUrl" [restrictions]="myRestrictions">
                              </kendo-upload>
                            </div>

                            <div class="col-xl-12">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>File Description</mat-label>
                                <input matInput placeholder="File Description" #fileDescription (input)="
                                fileDescriptionChange(
                                    tn.id,
                                    fileDescription.value
                                )
                                " />
                              </mat-form-field>
                            </div>
                          </div>

                          <!-- Instruction -->
                          <div *ngIf="tn.itemTypeText === 'Instruction'" class="row">
                            <div class="col-xl-12">
                              <kendo-editor class="droupdowndesign" [(ngModel)]="tn.instruction">
                                <kendo-toolbar [overflow]="true">
                                  <kendo-toolbar-buttongroup>
                                    <kendo-toolbar-button kendoEditorBoldButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorItalicButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorUnderlineButton>
                                    </kendo-toolbar-button>
                                  </kendo-toolbar-buttongroup>
                                  <kendo-toolbar-buttongroup>
                                    <kendo-toolbar-button kendoEditorAlignLeftButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorAlignCenterButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorAlignRightButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorAlignJustifyButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorInsertOrderedListButton>
                                    </kendo-toolbar-button>
                                    <kendo-toolbar-button kendoEditorInsertUnorderedListButton>
                                    </kendo-toolbar-button>
                                  </kendo-toolbar-buttongroup>
                                  <kendo-toolbar-dropdownlist kendoEditorFormat>
                                  </kendo-toolbar-dropdownlist>
                                  <kendo-toolbar-dropdownlist kendoEditorFontSize>
                                  </kendo-toolbar-dropdownlist>
                                  <kendo-toolbar-dropdownlist kendoEditorFontFamily>
                                  </kendo-toolbar-dropdownlist>
                                  <kendo-toolbar-colorpicker kendoEditorForeColor>
                                  </kendo-toolbar-colorpicker>
                                  <kendo-toolbar-colorpicker kendoEditorBackColor>
                                  </kendo-toolbar-colorpicker>
                                </kendo-toolbar>
                              </kendo-editor>
                            </div>
                          </div>
                          <!-- End Instruction -->
                          <!-- Chief Complaint -->
                          <div *ngIf="tn.itemTypeText === 'Chief Complaint'" class="row">
                            <div class="col-xl-12">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Default Notes</mat-label>
                                <textarea matInput rows="4" #chiefComplaint (input)="
                                chiefComplaintChange(
                                    tn.id,
                                    chiefComplaint.value
                                )
                                "></textarea>
                              </mat-form-field>
                            </div>
                          </div>
                          <!-- End Chief Complaint -->
                          <!-- Vitals -->
                          <div *ngIf="tn.itemTypeText === 'Vitals'" class="row">
                            <div class="col-xl-8">
                              <mat-form-field [appearance]="apperance" class="full-width">

                                <mat-label> Unit of Measurement</mat-label>

                                <mat-select (valueChange)="vitalsChange(tn.id, $event)" formControlName="vitals" [errorStateMatcher]="matcher" [value]="tn.vitals.vitalType">
                                  <mat-option value="Metric">Metric</mat-option>
                                  <mat-option value="Imperial">Imperial</mat-option>
                                </mat-select>

                                <mat-error *ngIf="(tn.vitals.vitalType==null && item.controls[i].get('vitals').value == '') || isSubmitted">
                                  This field is required.
                                </mat-error>
                              </mat-form-field>
                            </div>
                            <div class="row" style="padding: 0px 0px 0px 20px;">
                              <div class="col-md-3 mb-3" *ngFor="let u of unitOfMeasurement">
                                <mat-checkbox [value]="u.id" (change)="
                                unitOfMeasurementChange(tn.id, $event, u)
                                " class="mr-3" [checked]='u.isChecked'></mat-checkbox><span class="normal_14px_16px_font normalhelfont lightsgrey">
                                  {{
                                                                    u.name
                                  }}
                                </span>
                              </div>
                            </div>
                          </div>
                          <!-- End Vitals -->
                          <!-- Spine -->
                          <div *ngIf="tn.itemTypeText === 'Spine'" class="row">
                            <div class="col-xl-12">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Spine Notes</mat-label>
                                <textarea matInput rows="4" [value]="tn.spineNotes" #spine (input)="spineChange(tn.id, spine.value)"></textarea>
                              </mat-form-field>
                            </div>
                          </div>
                          <!-- End Spine -->
                          <!-- Optical Measurements -->
                          <div *ngIf="tn.itemTypeText === 'Optical Measurements'" class="row">
                            <div class="col-xl-12">
                              <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>Optical Notes</mat-label>
                                <textarea matInput rows="4" #optical [value]="tn.OpticalNotes" (input)="opticalChange(tn.id, optical.value)"></textarea>
                              </mat-form-field>
                            </div>
                          </div>
                          <!-- End Optical Measurements -->
                        </div>


                        <!-- Help Text  -->
                        <div class="col-xl-12 traetmentdulicatelabel-wrapper pl-0 pr-0" *ngIf="
                        tn.itemTypeText !== 'Vitals' &&
                        tn.itemTypeText !== 'Chief Complaint' &&
                        tn.itemTypeText !== 'Optical Measurements' &&
                        tn.itemTypeText !== 'Instruction' &&
                        tn.itemTypeText !== 'Spine'
                        ">
                          <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Help Text</mat-label>
                            <input matInput [value]="tn.helpText" placeholder="Help Text" #helpText (input)="helpTextChange(tn.id, helpText.value)" />
                          </mat-form-field>
                        </div>

                        <!-- Duplicate Help Text  -->
                        <div *ngIf="tn.showMirrored" class="col-xl-12 traetmentdulicatelabel-wrapper pl-0 pr-0">
                          <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Help Text</mat-label>
                            <input matInput placeholder="Help Text" [value]="tn.helpTextDuplicate" #duplicateHelpText (input)="
                            duplicateHelpTextChange(
                                tn.id,
                                duplicateHelpText.value
                            )
                            " />
                          </mat-form-field>
                        </div>

                        <!-- Include Notes For Checkbox Start -->
                        <div class="col-xl-12 mb-3 pl-0 pr-0" *ngIf="
                    tn.itemTypeText == 'Check Boxes'">

                          <mat-checkbox [checked]="tn.includeNotes" (change)="includeNotesValueChange(tn.id, $event)" class="dynamicheckbox c-checkbox lightsgrey">
                            Include Notes
                          </mat-checkbox>

                        </div>
                        <!-- Include Notes For Checkbox End -->


                        <div *ngIf="
                        tn.itemTypeText != 'Chief Complaint' &&
                        tn.itemTypeText != 'Vitals' &&
                        tn.itemTypeText != 'Spine' &&
                        tn.itemTypeText != 'Table' &&
                        tn.itemTypeText != 'File Attachment' &&
                        tn.itemTypeText != 'Chart' &&
                        tn.itemTypeText != 'Instruction' &&
                        tn.itemTypeText != 'Optical Measurements'
                        " class="col-xl-12 mb-3 pl-0 pr-0">
                          <mat-checkbox class="dynamicheckbox c-checkbox lightsgrey" [checked]="tn.showMirrored" (change)="mirroredValueChange(tn.id, $event,i)">
                            Show mirrored (For left/right or front/back type comparisions.)
                          </mat-checkbox>

                        </div>
                        <div *ngIf="
                        (tn.itemTypeText !== 'Heading' &&
                            tn.itemTypeText !== 'Instruction' &&
                            tn.itemTypeText !== 'Range or Scale' &&
                            tn.itemTypeText !== 'Table' &&
                            tn.itemTypeText !== 'Chart' &&
                            tn.itemTypeText !== 'Optical Measurements' &&
                            tn.itemTypeText !== 'Spine') ||
                        (tn.itemTypeText === 'Option List' &&
                            tn.optionListStyleId !== '2')
                        " class="col-xl-12 pl-0 pr-0">
                          <mat-checkbox class="dynamicheckbox c-checkbox lightsgrey" [checked]="tn.isMandatory" (change)="mandatoryValueChange(tn.id, $event)">
                            Make this a mandatory item
                          </mat-checkbox>

                        </div>
                        <button (click)="deleteData()" type="button" mat-raised-button class="deletebutton-wrapper deletebutton custom-delete-btn deletebutton-wrapper custom-delete-btn" style="margin-top: 20px">
                          Delete Item
                        </button>
                      </div>
                    </div>
                  </ng-container>
                  <!-- Delete All item start -->
                  <kendo-dialog *ngIf="opendeleteform" (close)="close('cancel')" [width]="400">
                    <span class="bold_18px_font blucolor uppercasetext">
                      DO YOU WISH TO DELETE THIS ITEM?
                    </span>
                    <mat-divider class="mt-3"></mat-divider>
                    <div class="modalClosebtn exportclose">
                      <button mat-icon-button (click)="close()" aria-label="Close dialog">
                        <mat-icon>close</mat-icon>
                      </button>
                    </div>
                    <div>
                      <p class="normal_14px_22px_font letterspacing_15 lightcolor ml-1 mt-2">
                        Deleted item cannot be restored.
                      </p>
                    </div>
                    <mat-divider></mat-divider>
                    <div class="bottom-bar-wrapper">
                      <div class="text-right control-row">
                        <div class="pt-3">
                          <button mat-stroked-button color="accent" class="mr-3 footer-btn-customize" (click)="close()">
                            No
                          </button>
                          <button mat-raised-button color="accent" class="wide footer-btn-customize" (click)="deleteItem(tn.id)">
                            <span>Yes</span>
                          </button>
                        </div>
                      </div>
                    </div>
                  </kendo-dialog>
                </mat-expansion-panel>
              </mat-accordion>
            </div>
          </div>
        </form>

      </div>
      <div class="bottom-bar-wrapper" *ngIf="treatmentNotes">
        <div class="text-left control-row ">
          <div class="pt-3" *appAccess="moduleName;lookFor: 'D'">

            <button *ngIf="deleteButton" mat-raised-button color="accent" (click)="openDelete()" class="deletebutton-wrapper deletebutton custom-delete-btn">
              Delete
            </button>
          </div>
        </div>
        <div class="text-right control-row">
          <div class="pt-3">
            <button mat-stroked-button color="accent" class="mr-3" (click)="cancel()">
              Cancel
            </button>
            <button *appAccess="moduleName;lookFor: ['C', 'E']" mat-raised-button color="accent" class="footer-btn-customize" (click)="createTreatmentNotes()">
              <span *ngIf="!submitting">Save</span>
              <span *ngIf="submitting">Saving...</span>
            </button>

          </div>
        </div>
      </div>

    </div>


    <!-- Preview -->
    <div class="col-xl-6">
      <div class="tab bg-white">
        <div class="row">
          <div class="col-xl-6 col-lg-6 d-flex align-items-center">
            <button class="tablinks active ">
              <span class="normal_18px_font lightcolor">Preview</span>
            </button>
          </div>
          <div class="col-xl-6 col-lg-6 d-flex justify-content-end align-items-center">
            <h5 class="mr-2 mb-0">Status</h5>
            <div class="mr-2">
              <kendo-switch [onLabel]="'Active'" [offLabel]="'Inactive'" [(ngModel)]="treatmentNotes.isStatus" [ngModelOptions]="{ standalone: true }" class="wider-switch">
              </kendo-switch>
            </div>
          </div>
        </div>
      </div>

      <div class="tabcontent bg-white" style="max-height: 500px;overflow-y: scroll;overflow-x: hidden;">
        <app-treatment-notes-preview [treatmentNotes]="treatmentNotes" [unitOfMeasurement]="unitOfMeasurement"></app-treatment-notes-preview>
      </div>
    </div>
  </div>
</div>


<kendo-dialog title="Please confirm" *ngIf="openedDelete" (close)="closeDelete()" [minWidth]="250" [width]="450">
  <p style="margin: 30px; text-align: center">
    Are you sure you want to delete?
  </p>
  <kendo-dialog-actions>
    <button kendoButton (click)="closeDelete()" class="footer-btn-customize">No</button>
    <button kendoButton (click)="deleteTreatmentNotesTemplate()" primary="true" class="footer-btn-customize">
      Yes
    </button>
  </kendo-dialog-actions>
</kendo-dialog>

<kendo-dialog title="DO YOU WISH TO DUPLICATE THIS TREATMENT NOTES TEMPLATE?" *ngIf="openedDuplicate" (close)="closeDuplicate()" [minWidth]="250" [width]="750">
  <p style="margin: 30px; text-align: center">
    Click "Yes", to save the changes made to the current template and create a duplicate.
  </p>
  <kendo-dialog-actions>
    <button kendoButton (click)="closeDuplicate()" class="footer-btn-customize">No</button>
    <button kendoButton (click)="copyTemplate()" primary="true" class="footer-btn-customize">Yes</button>
  </kendo-dialog-actions>
</kendo-dialog>
